/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.util;

import fr.cenra.rhomeo.core.RhomeoCore;
import java.io.IOException;
import java.util.List;
import javax.xml.stream.XMLStreamException;
import org.geotoolkit.data.kml.model.Extensions;
import org.geotoolkit.data.kml.model.Extensions.Names;
import org.geotoolkit.data.kml.model.KmlException;
import org.geotoolkit.data.kml.xml.KmlExtensionWriter;
import org.geotoolkit.data.kml.xsd.SimpleTypeContainer;
import org.geotoolkit.xml.StaxStreamWriter;

/**
 * Customized {@link KmlExtensionWriter} for Rhomeo site attribute data.
 * 
 * @author Samuel Andrés (Geomatys)
 */
public class RhomeoKmlWriter extends StaxStreamWriter implements KmlExtensionWriter{

    public static final String NAMESPACE = "http://rhomeo.cenra.fr/kml";
    
    public static final String TAG_COUNTY = RhomeoCore.FT_PROPERTIES.COUNTY.name();
    public static final String TAG_TYPE = RhomeoCore.FT_PROPERTIES.TYPE.name();
    public static final String TAG_ODONATE = RhomeoCore.FT_PROPERTIES.ODONATE.name();
    public static final String TAG_ORTHOPTERE = RhomeoCore.FT_PROPERTIES.ORTHOPTERE.name();

    public RhomeoKmlWriter(){
        super();
    }

    /**
     *
     * @param output
     * @throws XMLStreamException
     * @throws IOException
     */
    @Override
    public void setOutput(Object output) throws XMLStreamException, IOException{
        super.setOutput(output);
    }

    private void writeStringElement(final String tag, final String content) throws XMLStreamException{
            writer.writeStartElement(NAMESPACE, tag);
            writer.writeCharacters(content);
            writer.writeEndElement();
    }

    @Override
    public boolean canHandleComplex(final String kmlVersionUri, final Names ext, final Object contentObject) {
        if(contentObject instanceof List){
            return true;
        }
        return false;
    }

    @Override
    public boolean canHandleSimple(final String kmlVersionUri, final Names ext, final String elementTag) {
        if(TAG_COUNTY.equals(elementTag)  
                || TAG_TYPE.equals(elementTag)
                || TAG_ODONATE.equals(elementTag) 
                || TAG_ORTHOPTERE.equals(elementTag)){
            return true;
        }
        return false;
    }

    @Override
    public void writeComplexExtensionElement(String kmlVersionUri, Extensions.Names ext, Object contentElement)
            throws XMLStreamException, KmlException {
        throw new UnsupportedOperationException("Does not support complex types.");
    }

    @Override
    public void writeSimpleExtensionElement(final String kmlVersionUri, final Extensions.Names ext, final SimpleTypeContainer contentElement)
            throws XMLStreamException, KmlException {
        if(TAG_COUNTY.equals(contentElement.getTagName())  
                || TAG_TYPE.equals(contentElement.getTagName())
                || TAG_ODONATE.equals(contentElement.getTagName()) 
                || TAG_ORTHOPTERE.equals(contentElement.getTagName())){
            final Object value = contentElement.getValue();
            if(value!=null) this.writeStringElement(contentElement.getTagName(), value.toString());
        }
    }
}
